Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_capture.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_capture.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_capture.php	(revision )
@@ -23,6 +23,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $shorttag_order = array('name');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -34,12 +35,12 @@
     /**
      * Compiles code for the {capture} tag
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
@@ -51,11 +52,31 @@
         $compiler->_capture_stack[0][] = array($buffer, $assign, $append, $compiler->nocache);
         // maybe nocache because of nocache variables
         $compiler->nocache = $compiler->nocache | $compiler->tag_nocache;
-        $_output = "<?php \$_smarty_tpl->_capture_stack[0][] = array($buffer, $assign, $append); ob_start(); ?>";
+        $_output = "<?php \$_smarty_tpl->_cache['capture_stack'][] = array($buffer, $assign, $append); ob_start(); ?>";
 
         return $_output;
     }
+
+    /**
+     * Compiles code for the {$smarty.capture.xxx}
+     *
+     * @param  array                                $args      array with attributes from parser
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
+     * @param  array                                $parameter array with compilation parameter
+     *
+     * @return string compiled code
+     * @throws \SmartyCompilerException
+     */
+    public static function compileSpecialVariable($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
+    {
+        $tag = strtolower(trim($parameter[ 0 ], '"\''));
+        $name = isset($parameter[ 1 ]) ? $compiler->getId($parameter[ 1 ]) : false;
+        if (!$name) {
+            $compiler->trigger_template_error("missing or illegal \$smarty.{$tag} name attribute", null, true);
-}
+        }
+        return "(isset(\$_smarty_tpl->_cache['__smarty_capture']['{$name}']) ? \$_smarty_tpl->_cache['__smarty_capture']['{$name}'] : null)";
+    }
+}
 
 /**
  * Smarty Internal Plugin Compile Captureclose Class
@@ -68,12 +89,12 @@
     /**
      * Compiles code for the {/capture} tag
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
@@ -84,11 +105,11 @@
 
         list($buffer, $assign, $append, $compiler->nocache) = array_pop($compiler->_capture_stack[0]);
 
-        $_output = "<?php list(\$_capture_buffer, \$_capture_assign, \$_capture_append) = array_pop(\$_smarty_tpl->_capture_stack[0]);\n";
+        $_output = "<?php list(\$_capture_buffer, \$_capture_assign, \$_capture_append) = array_pop(\$_smarty_tpl->_cache['capture_stack']);\n";
         $_output .= "if (!empty(\$_capture_buffer)) {\n";
         $_output .= " if (isset(\$_capture_assign)) \$_smarty_tpl->assign(\$_capture_assign, ob_get_contents());\n";
         $_output .= " if (isset( \$_capture_append)) \$_smarty_tpl->append( \$_capture_append, ob_get_contents());\n";
-        $_output .= " Smarty::\$_smarty_vars['capture'][\$_capture_buffer]=ob_get_clean();\n";
+        $_output .= "\$_smarty_tpl->_cache['__smarty_capture'][\$_capture_buffer]=ob_get_clean();\n";
         $_output .= "} else \$_smarty_tpl->capture_error();?>";
 
         return $_output;
Index: src/includes/classes/Smarty/sysplugins/smartyexception.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smartyexception.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smartyexception.php	(revision )
@@ -0,0 +1,15 @@
+<?php
+/**
+ * Smarty exception class
+ *
+ * @package Smarty
+ */
+class SmartyException extends Exception
+{
+    public static $escape = false;
+
+    public function __toString()
+    {
+        return ' --> Smarty: ' . (self::$escape ? htmlentities($this->message) : $this->message) . ' <-- ';
+    }
+}
Index: src/includes/classes/Smarty/plugins/modifier.regex_replace.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifier.regex_replace.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifier.regex_replace.php	(revision )
@@ -19,10 +19,11 @@
  * @param string       $string  input string
  * @param string|array $search  regular expression(s) to search for
  * @param string|array $replace string(s) that should be replaced
+ * @param int          $limit   the maximum number of replacements
  *
  * @return string
  */
-function smarty_modifier_regex_replace($string, $search, $replace)
+function smarty_modifier_regex_replace($string, $search, $replace, $limit = -1)
 {
     if (is_array($search)) {
         foreach ($search as $idx => $s) {
@@ -32,7 +33,7 @@
         $search = _smarty_regex_replace_check($search);
     }
 
-    return preg_replace($search, $replace, $string);
+    return preg_replace($search, $replace, $string, $limit);
 }
 
 /**
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_code.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_code.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_code.php	(revision )
@@ -0,0 +1,42 @@
+<?php
+/**
+ * Smarty Internal Plugin Templateparser Parse Tree
+ * These are classes to build parse trees in the template parser
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @author     Thue Kristensen
+ * @author     Uwe Tews
+ */
+
+/**
+ * Code fragment inside a tag .
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @ignore
+ */
+class Smarty_Internal_ParseTree_Code extends Smarty_Internal_ParseTree
+{
+    /**
+     * Create parse tree buffer for code fragment
+     *
+     * @param string $data content
+     */
+    public function __construct($data)
+    {
+        $this->data = $data;
+    }
+
+    /**
+     * Return buffer content in parentheses
+     *
+     * @param \Smarty_Internal_Templateparser $parser
+     *
+     * @return string content
+     */
+    public function to_smarty_php(Smarty_Internal_Templateparser $parser)
+    {
+        return sprintf("(%s)", $this->data);
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_extension_handler.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_extension_handler.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_extension_handler.php	(revision )
@@ -0,0 +1,157 @@
+<?php
+
+/**
+ * Smarty Extension handler
+ *
+ * Load extensions dynamically
+ *
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ *
+ * @property Smarty_Internal_Runtime_Inheritance      $_inheritance
+ * @property Smarty_Internal_Runtime_SubTemplate      $_subTemplate
+ * @property Smarty_Internal_Runtime_TplFunction      $_tplFunction
+ * @property Smarty_Internal_Runtime_Var              $_var
+ * @property Smarty_Internal_Runtime_Config           $_config
+ * @property Smarty_Internal_Runtime_Foreach          $_foreach
+ * @property Smarty_Internal_Runtime_Hhvm             $_hhvm
+ * @property Smarty_Internal_Runtime_WriteFile        $_writeFile
+ * @property Smarty_Internal_Runtime_ValidateCompiled $_validateCompiled
+ * @property Smarty_Internal_Runtime_CodeFrame        $_codeFrame
+ * @property Smarty_Internal_Runtime_FilterHandler    $_filterHandler
+ * @property Smarty_Internal_Runtime_GetIncludePath   $_getIncludePath
+ * @property Smarty_Internal_Runtime_UpdateScope      $_updateScope
+ * @property Smarty_Internal_Runtime_IsCached         $_isCached
+ * @property Smarty_Internal_Runtime_CacheModify      $_cacheModify
+ * @property Smarty_Internal_Runtime_UpdateCache      $_updateCache
+ * @property Smarty_Internal_Method_GetTemplateVars   $getTemplateVars
+ * @property Smarty_Internal_Method_Append            $append
+ * @property Smarty_Internal_Method_AppendByRef       $appendByRef
+ * @property Smarty_Internal_Method_AssignGlobal      $assignGlobal
+ * @property Smarty_Internal_Method_AssignByRef       $assignByRef
+ * @property Smarty_Internal_Method_LoadFilter        $loadFilter
+ * @property Smarty_Internal_Method_LoadPlugin        $loadPlugin
+ * @property Smarty_Internal_Method_RegisterFilter    $registerFilter
+ * @property Smarty_Internal_Method_RegisterObject    $registerObject
+ * @property Smarty_Internal_Method_RegisterPlugin    $registerPlugin
+ */
+class Smarty_Internal_Extension_Handler
+{
+
+    public $objType = null;
+
+    /**
+     * Cache for property information from generic getter/setter
+     * Preloaded with names which should not use with generic getter/setter
+     *
+     * @var array
+     */
+    private $_property_info = array('AutoloadFilters' => 0, 'DefaultModifiers' => 0, 'ConfigVars' => 0,
+                                    'DebugTemplate'   => 0, 'RegisteredObject' => 0, 'StreamVariable' => 0,
+                                    'TemplateVars'    => 0,);#
+
+    private $resolvedProperties = array();
+
+    /**
+     * Call external Method
+     *
+     * @param \Smarty_Internal_Data $data
+     * @param string                $name external method names
+     * @param array                 $args argument array
+     *
+     * @return mixed
+     * @throws SmartyException
+     */
+    public function _callExternalMethod(Smarty_Internal_Data $data, $name, $args)
+    {
+        /* @var Smarty $data ->smarty */
+        $smarty = isset($data->smarty) ? $data->smarty : $data;
+        if (!isset($smarty->ext->$name)) {
+            $class = 'Smarty_Internal_Method_' . ucfirst($name);
+            if (preg_match('/^(set|get)([A-Z].*)$/', $name, $match)) {
+                if (!isset($this->_property_info[$prop = $match[2]])) {
+                    // convert camel case to underscored name
+                    $this->resolvedProperties[$prop] = $pn = strtolower(join('_',
+                                                                             preg_split('/([A-Z][^A-Z]*)/', $prop, - 1,
+                                                                                        PREG_SPLIT_NO_EMPTY |
+                                                                                        PREG_SPLIT_DELIM_CAPTURE)));
+                    $this->_property_info[$prop] = property_exists($data, $pn) ? 1 :
+                        ($data->_objType == 2 && property_exists($smarty, $pn) ? 2 : 0);
+                }
+                if ($this->_property_info[$prop]) {
+                    $pn = $this->resolvedProperties[$prop];
+                    if ($match[1] == 'get') {
+                        return $this->_property_info[$prop] == 1 ? $data->$pn : $data->smarty->$pn;
+                    } else {
+                        return $this->_property_info[$prop] == 1 ? $data->$pn = $args[0] :
+                            $data->smarty->$pn = $args[0];
+                    }
+                } elseif (!class_exists($class)) {
+                    throw new SmartyException("property '$pn' does not exist.");
+                }
+            }
+            if (class_exists($class)) {
+                $callback = array($smarty->ext->$name = new $class(), $name);
+            }
+        } else {
+            $callback = array($smarty->ext->$name, $name);
+        }
+        array_unshift($args, $data);
+        if (isset($callback) && $callback[0]->objMap | $data->_objType) {
+            return call_user_func_array($callback, $args);
+        }
+        return call_user_func_array(array(new Smarty_Internal_Undefined(), $name), $args);
+    }
+
+    /**
+     * set extension property
+     *
+     * @param string $property_name property name
+     * @param mixed  $value         value
+     *
+     * @throws SmartyException
+     */
+    public function __set($property_name, $value)
+    {
+        $this->$property_name = $value;
+    }
+
+    /**
+     * get extension object
+     *
+     * @param string $property_name property name
+     *
+     * @return mixed|Smarty_Template_Cached
+     * @throws SmartyException
+     */
+    public function __get($property_name)
+    {
+        // object properties of runtime template extensions will start with '_'
+        if ($property_name[0] == '_') {
+            $class = 'Smarty_Internal_Runtime_' . ucfirst(substr($property_name, 1));
+        } else {
+            $class = 'Smarty_Internal_Method_' . ucfirst($property_name);
+        }
+        if (class_exists($class)) {
+            return $this->$property_name = new $class();
+        }
+        return $this;
+    }
+
+    /**
+     * Call error handler for undefined method
+     *
+     * @param string $name unknown method-name
+     * @param array  $args argument array
+     *
+     * @return mixed
+     * @throws SmartyException
+     */
+    public function __call($name, $args)
+    {
+        return call_user_func_array(array(new Smarty_Internal_Undefined(), $name), $args);
+    }
+
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/plugins/modifiercompiler.strip_tags.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.strip_tags.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.strip_tags.php	(revision )
@@ -12,7 +12,7 @@
  * Name:     strip_tags<br>
  * Purpose:  strip html tags from text
  *
- * @link   http://www.smarty.net/manual/en/language.modifier.strip.tags.php strip_tags (Smarty online manual)
+ * @link   http://www.smarty.net/docs/en/language.modifier.strip.tags.tpl strip_tags (Smarty online manual)
  * @author Uwe Tews
  *
  * @param array $params parameters
